package de.fhdw.gaming.ipspiel23.ht.strategy.factory;

import java.util.List;
import java.util.ServiceLoader;
import java.util.stream.Collectors;

import de.fhdw.gaming.ipspiel23.ht.strategy.IHTStrategyFactory;

/**
 * Provides a list of {@link IHTStrategyFactory} instances.
 */
public final class HTDefaultStrategyFactoryProvider implements IHTStrategyFactoryProvider {

    @Override
    public List<IHTStrategyFactory> getStrategyFactories() {
        // probably does some reflection magic to load implementing classes
        return ServiceLoader.load(IHTStrategyFactory.class)
            .stream()
            .map(provider -> provider.get())
            .collect(Collectors.toList());
    }
}
