package de.fhdw.gaming.ipspiel23.ht.strategy.impl.tails;

import java.util.Optional;

import de.fhdw.gaming.core.domain.GameException;
import de.fhdw.gaming.ipspiel23.ht.domain.IHTPlayer;
import de.fhdw.gaming.ipspiel23.ht.domain.IHTState;
import de.fhdw.gaming.ipspiel23.ht.moves.IHTMove;
import de.fhdw.gaming.ipspiel23.ht.moves.factory.IHTMoveFactory;
import de.fhdw.gaming.ipspiel23.ht.strategy.impl.HTStrategy;

/**
 * Implements {@link HTStrategy} by always playing "tails".
 */
public class HTTailsStrategy extends HTStrategy {

    /**
     * Creates an {@link HTTailsStrategy}.
     * @param moveFactory The factory for creating HT moves.
     */
    protected HTTailsStrategy(final IHTMoveFactory moveFactory) {
        super(moveFactory);
    }

    @Override
    public Optional<IHTMove> computeNextMove(final int gameId, final IHTPlayer player, final IHTState state)
            throws GameException, InterruptedException {
        return Optional.of(getMoveFactory().createTailsMove());
    }
}
